#!/bin/bash

~/dev/graph_knife/graph_knife -O maxcomponent ~/data/graph-db/porter/Stanford3.smat Stanford3-cc -f smat --verbose

SYMGRAPHS="ca-AstroPh ca-CondMat ca-GrQc ca-HepPh ca-HepTh email-Enron"
for graph in $SYMGRAPHS; do
  ~/dev/graph_knife/graph_knife -O maxcomponent ~/data/graph-db/snap/$graph.smat $graph-cc -f smat --verbose
done


SRCGRAPHS="wiki-Vote soc-Epinions1 email-EuAll"
for graph in $SRCGRAPHS; do
  ~/dev/graph_knife/graph_knife --symmetrize -O maxcomponent ~/data/graph-db/snap/$graph.smat $graph-wcc -f smat --verbose
done

CONGRAPHS="soc-Slashdot0811"
for graph in $CONGRAPHS; do
  ~/dev/matrix_xform/matrix_xform ~/data/graph-db/snap/$graph.smat --symmetrize --verbose -o $graph-wcc.smat -f smat 
done

# matlab to smat
matlab -nodisplay -nosplash -nojvm -r "addpath('../matlab'); load('flickr2.mat'); writeSMAT('flickr2.smat',B); exit"
matlab -nodisplay -nosplash -nojvm -r "addpath('../matlab'); load('arxiv.mat'); writeSMAT('arxiv.smat',B); exit"
matlab -nodisplay -nosplash -nojvm -r "addpath('../matlab'); load('dblp.mat'); writeSMAT('dblp.smat',B); exit"

matlab -nodisplay -nosplash -nojvm -r "addpath('../matlab'); load('dblp_lcc.mat'); writeSMAT('dblp_lcc.smat',A); exit"
matlab -nodisplay -nosplash -nojvm -r "addpath('../matlab'); load('arxiv_lcc.mat'); writeSMAT('arxiv_lcc.smat',A); exit"


