%% Evaluate the precision of our approximate topk commute time
% For a real-world graph, we see how badly the inaccurate diagonal
% estimation from cgLanczos affects the precision in the top 100 commute
% time neighbors.

addpath('../../matlab');
%% Real world graph
A = readSMAT('../../data/stanford-cs-sym.smat');
C = load_scalapack_matrix('../../data/stanford-cs-sym.smat.laplacian.ctimes.gz');
dexact = load('../../data/stanford-cs-sym.smat.laplacian.pinvdiags');
n = size(A,1);
deg = sum(A,1)';
graphname = 'cs-stan';

%% Setup figures
set(0, ...
    'defaultaxesfontsize',   16, ...
    'defaultaxeslinewidth',   1.5, ...
    'defaultlinelinewidth',   2, ...
    'defaultpatchlinewidth',  1.1);

%% Track errors in the digaonal entries
niters = [10 20 50 100 200 500 1000 2000 5000];
for ii=1:length(niters)
    ni = niters(ii);
    [x,res,d] = commute_topk(A,ni);
    
end
    

