%% A first test of commute_topk
% This experiment is a first, initial, test of commute_topk.


%% setup
addpath('../../matlab');
%% load data
A = readSMAT('../../data/tapir.smat');
C = load_scalapack_matrix('../../data/tapir.smat.laplacian.ctimes.gz');
dexact = load('../../data/tapir.smat.laplacian.pinvdiags');
xy = load('../../data/tapir.xy');

%% test plotting of tapir
v = 51;
[hg,hp] = mygplot(A,xy,C(v,:));
colormap(flipud(hot));
set(hp,'SizeData',40);

%% check results with the exact diagonal
[cv,res,dt] = commute_topk(A,v,'tol',1e-16,'diag',dexact);
norm(C(:,v)-cv)
subplot(2,1,1);
plot(C(:,v),cv,'.');
subplot(2,1,2);
plot(C(:,v),abs(C(:,v)-cv),'.');

%% check results on real data
[cv,dt,res] = commute_topk(A,v,'tol',1e-8,'maxit',5000);
subplot(2,1,1);
plot(cv,C(:,v),'.');
subplot(2,1,2);
plot(dt,dexact,'.');

%%
% show similarity
isk = isim(-cv,-C(:,v));
plot(isk);

