%% Analyze localization

%% Load the data
load katz_localization_study

%% rewrite the graph names
shortnames = {};
for gi=1:length(graphs);
    name = graphs{gi};
    name = name(1:end-5); % truncate .smat
    if strendswith(name,'-cc')
        name = name(1:end-3);
    elseif strendswith(name,'-wcc');
        name = name(1:end-4);
    elseif strendswith(name,'_lcc');
        name = name(1:end-4);
    end
    shortnames{gi} = name;
end
    

%% Group the localization by graph 
loclevel = 6;
katz_localization_plot;
% boxparents=get(h,'parent');
% boxparent = boxparents{1};
% notify(handle(boxparent),'DeleteFcn');

%greygrid;

print(gcf,sprintf('katz-localization-%.2f.eps',locpts(loclevel)),...
    '-depsc2','-cmyk');

%% Group the localization by graph 
loclevel = 4;
katz_localization_plot;
% boxparents=get(h,'parent');
% boxparent = boxparents{1};
% notify(handle(boxparent),'DeleteFcn');

%greygrid;
print(gcf,sprintf('katz-localization-%.2f.eps',locpts(loclevel)),...
    '-depsc2','-cmyk');

%% Print a table of the ipar scores
nresults = length(results);
ipars = [];
gs = [];
gsize = [];
nverts = [];
nedges = [];
for i=1:length(results)
    if strcmp(results(i).type,'all'), continue; end
    ipars = [ipars 1./results(i).ipar];
    gs = [gs results(i).gi];
    nverts(results(i).gi) = results(i).nverts;
    nedges(results(i).gi) = results(i).nedges;
end

mins = accumarray(gs(:),ipars(:),[],@min);
maxs = accumarray(gs(:),ipars(:),[],@max);
means = accumarray(gs(:),ipars(:),[],@mean);
medians = accumarray(gs(:),ipars(:),[],@median);

[ignore p] = sort(nverts);

for pgi=1:length(graphs)
    gi = p(pgi);
    fprintf('%20s & %7i & %5.1f & %3.1f & %6.1f & %6.1f & %6.1f \\\\\n', ...
        shortnames{gi}, nverts(gi), nedges(gi)/nverts(gi), mins(gi),  means(gi), medians(gi), maxs(gi));
end

