%% Load the data
load katz_runtime_all

%% rewrite the graph names
shortnames = {};
for gi=1:length(graphs);
    name = graphs{gi};
    name = name(1:end-5); % truncate .smat
    if strendswith(name,'-cc')
        name = name(1:end-3);
    elseif strendswith(name,'-wcc');
        name = name(1:end-4);
    elseif strendswith(name,'_lcc');
        name = name(1:end-4);
    end
    shortnames{gi} = name;
end
    
%% aggregate results

nresults = length(results);
ipars = [];
kverts = [];
kedges = [];
dts = [];

vtypes = [];

gs = [];

nverts = [];
nedges = [];
for i=1:length(results)
    if strcmp(results(i).type,'degree'), vtype = 1; 
    else vtype = 2;
    end
    
    ipars = [ipars 1./results(i).ipar];
    gs = [gs results(i).gi];
    vtypes = [vtypes vtype];
    
    dts = [dts results(i).time];
    
    kverts = [kverts results(i).kverts];
    kedges = [kedges results(i).kedges];
    
    nverts(results(i).gi) = results(i).nverts;
    nedges(results(i).gi) = results(i).nedges;
end

vtype = vtype(:);
gs = gs(:);
dts = dts(:);

% get data for the degree correlated vertices
ddt25 = accumarray(gs(vtypes==1),dts(vtypes==1),[],@(x) prctile(x,25));
ddt50 = accumarray(gs(vtypes==1),dts(vtypes==1),[],@(x) prctile(x,50));
ddt75 = accumarray(gs(vtypes==1),dts(vtypes==1),[],@(x) prctile(x,75));

% get data for the random vertices
rdt25 = accumarray(gs(vtypes==2),dts(vtypes==2),[],@(x) prctile(x,25));
rdt50 = accumarray(gs(vtypes==2),dts(vtypes==2),[],@(x) prctile(x,50));
rdt75 = accumarray(gs(vtypes==2),dts(vtypes==2),[],@(x) prctile(x,75));


[ignore p] = sort(nverts);

for pgi=1:length(graphs)
    gi = p(pgi);
    fprintf('%20s & %7i & %5.1f & %6.1f & %6.1f & %6.1f & %6.1f & %6.1f & %6.1f \\\\\n', ...
        shortnames{gi}, nverts(gi), nedges(gi)/nverts(gi), rdt25(gi), rdt50(gi), rdt75(gi), ddt25(gi), ddt50(gi), ddt75(gi));
end


