%load 'katz_pairwise_mv_results';
%load 'commute_pairwise_mv_results'; 

% enumerate the graphs

ratios = [];
labels = [];
gnames = {};
nverts = [];
nedges = [];
aedges = [];
for gi=1:length(results)
    ratios = [ratios results(gi).ratios'];
    labels = [labels gi*ones(1,length(results(gi).ratios))];
    name = results(gi).name;
    name = name(1:end-5); % truncate .smat
    if strendswith(name,'-cc')
        name = name(1:end-3);
    elseif strendswith(name,'-wcc');
        name = name(1:end-4);
    elseif strendswith(name,'_lcc');
        name = name(1:end-4);
    end
    gnames{gi} = name;
    nedges(gi) = results(gi).nedges;
    nverts(gi) = results(gi).nverts;
    aedges(gi) = results(gi).nedges/results(gi).nverts;
end

%% 
[ignore p] = sort(aedges);
invp(p) = 1:length(p);
labels = invp(labels);
gnames = gnames(p);

%%
boxplot(ratios,labels,'orientation','horizontal','plotstyle','compact','jitter',1,...
    'labels',gnames,'outliersize',3,'symbol','k+');