
addpath('../../tools');
%%
load 'katz_pairwise_mv_results';
katztimes = summarize_runtime(results,'mmq_time');

%%
load 'commute_pairwise_mv_results'; 
[commtimes,gdata] = summarize_runtime(results,'mmq_time');

%%
% sort the graph data
graphs = gdata.keys;
gstats = cell2mat(gdata.values');
[ignore p] = sort(gstats(:,1)); % sort by vertices

for pi=1:length(p)
    gi = p(pi);
    g = graphs{gi};
    shortname = adjust_graphname(g);
    ktimes = katztimes(g);
    ctimes = commtimes(g);
    
    fprintf('%20s & %7i & %5.1f & %6.1f & %6.1f & %6.1f & %6.1f & %6.1f & %6.1f \\\\\n', ...
        shortname, gstats(gi,1), gstats(gi,2)/gstats(gi,1), ...
        prctile(ktimes,25), prctile(ktimes,50), prctile(ktimes,75), ...
        prctile(ctimes,25), prctile(ctimes,50), prctile(ctimes,75));
end
