function [graphmap,graphdata] = summarize_runtime(results,field)
% Given a structure
%   results(i).(field)
%   resutls(i).name
% return a dictionary indexed against name with the contents of field
% and a dictionary indexed against name with the contents of nverts and
% nedges for each graph
% 

graphmap = containers.Map();
graphdata = containers.Map();

for gi=1:length(results)
    name = results(gi).name;
    times = results(gi).(field);
    nverts = results(gi).nverts;
    nedges = results(gi).nedges;
    
    graphmap(name) = times;
    graphdata(name) = [nverts,nedges];

end